Index: src/xc/xc_libxc.F
===================================================================
--- src/xc/xc_libxc.F	(revision 18250)
+++ src/xc/xc_libxc.F	(working copy)
@@ -1146,6 +1129,7 @@
 !> \param params parameters of the functional
 !> \author F. Tran
 ! **************************************************************************************************
+#if defined (__LIBXC)
    SUBROUTINE libxc_lda_calc(rho, norm_drho, laplace_rho, tau, &
                              e_0, e_rho, e_ndrho, e_laplace_rho, e_tau, e_rho_rho, e_ndrho_rho, &
                              e_ndrho_ndrho, e_rho_laplace_rho, e_rho_tau, e_ndrho_laplace_rho, &
@@ -1154,43 +1138,44 @@
                              grad_deriv, npoints, epsilon_rho, &
                              epsilon_tau, func_name, sc, params)
 
-      REAL(KIND=dp), DIMENSION(*), INTENT(IN)  :: rho, norm_drho, laplace_rho, &
-                                                  tau
-      REAL(KIND=dp), DIMENSION(*), INTENT(INOUT) :: e_0, e_rho, e_ndrho, &
-                                                    e_laplace_rho, e_tau, e_rho_rho, e_ndrho_rho, e_ndrho_ndrho, &
-                                                    e_rho_laplace_rho, e_rho_tau, e_ndrho_laplace_rho, e_ndrho_tau, &
-                                                    e_laplace_rho_laplace_rho, e_laplace_rho_tau, e_tau_tau, e_rho_rho_rho
-      INTEGER, INTENT(in)                      :: grad_deriv, npoints
-      REAL(KIND=dp), INTENT(in)                :: epsilon_rho, epsilon_tau
-      CHARACTER(LEN=80), INTENT(IN)            :: func_name
-      REAL(KIND=dp), INTENT(in)                :: sc
-      REAL(KIND=dp), DIMENSION(*), INTENT(IN)  :: params
+      REAL(KIND=dp), DIMENSION(*), INTENT(IN)            :: rho, norm_drho, laplace_rho, tau
+      REAL(KIND=dp), DIMENSION(*), INTENT(INOUT) :: e_0, e_rho, e_ndrho, e_laplace_rho, e_tau, &
+         e_rho_rho, e_ndrho_rho, e_ndrho_ndrho, e_rho_laplace_rho, e_rho_tau, e_ndrho_laplace_rho, &
+         e_ndrho_tau, e_laplace_rho_laplace_rho, e_laplace_rho_tau, e_tau_tau, e_rho_rho_rho
+      INTEGER, INTENT(in)                                :: grad_deriv, npoints
+      REAL(KIND=dp), INTENT(in)                          :: epsilon_rho, epsilon_tau
+      CHARACTER(LEN=default_string_length), INTENT(IN)   :: func_name
+      REAL(KIND=dp), INTENT(in)                          :: sc
+      REAL(KIND=dp), DIMENSION(:), INTENT(IN), POINTER   :: params
 
-      CHARACTER(len=*), PARAMETER :: routineN = 'libxc_lda_calc', &
-                                     routineP = moduleN//':'//routineN
+      CHARACTER(len=*), PARAMETER :: routineN = 'libxc_lda_calc', routineP = moduleN//':'//routineN
 
-#if defined (__LIBXC)
-      INTEGER                                  :: func_id, ii
-      LOGICAL                                  :: no_exc
-      REAL(KIND=dp) :: exc, my_tau, v2lapl2, v2lapltau, v2rho2, v2rholapl, &
-                       v2rhosigma, v2rhotau, v2sigma2, v2sigmalapl, v2sigmatau, v2tau2, &
-                       v3rho3, vlapl, vrho, vsigma, vtau
-      TYPE(xc_f90_pointer_t)                   :: xc_func, xc_info
+      INTEGER                                            :: func_id, ii
+      LOGICAL                                            :: no_exc
+      REAL(KIND=dp), DIMENSION(1) :: exc, my_tau, sigma, v2lapl2, v2lapltau, v2rho2, v2rholapl, &
+         v2rhosigma, v2rhotau, v2sigma2, v2sigmalapl, v2sigmatau, v2tau2, v3rho3, vlapl, vrho, &
+         vsigma, vtau
+      TYPE(xc_f03_func_info_t)                           :: xc_info
+      TYPE(xc_f03_func_t)                                :: xc_func
 
+      ! init vlapl (prevent libxc-4.0.x bug)
+      vlapl = 0.0_dp
+
       func_id = xc_libxc_wrap_functional_get_number(func_name)
 !$OMP CRITICAL(libxc_init)
-      CALL xc_f90_func_init(xc_func, xc_info, func_id, XC_UNPOLARIZED)
-      CALL xc_libxc_wrap_functional_set_params(xc_func, xc_info, func_id, params, no_exc)
+      CALL xc_f03_func_init(xc_func, func_id, XC_UNPOLARIZED)
+      xc_info = xc_f03_func_get_info(xc_func)
+      CALL xc_libxc_wrap_functional_set_params(xc_func, xc_info, params, no_exc)
 !$OMP END CRITICAL(libxc_init)
 !$OMP BARRIER
-      SELECT CASE (xc_f90_info_family (xc_info))
+      SELECT CASE (xc_f03_func_info_get_family (xc_info))
       CASE (XC_FAMILY_LDA)
          IF (grad_deriv == 0) THEN
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
-                  CALL xc_f90_lda_exc(xc_func, 1, rho(ii), exc)
-                  e_0(ii) = e_0(ii)+sc*exc*rho(ii)
+                  CALL xc_f03_lda_exc(xc_func, 1, rho(ii), exc)
+                  e_0(ii) = e_0(ii)+sc*exc(1)*rho(ii)
                END IF
             END DO
 !$OMP           END DO
@@ -1198,8 +1183,8 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
-                  CALL xc_f90_lda_vxc(xc_func, 1, rho(ii), vrho)
-                  e_rho(ii) = e_rho(ii)+sc*vrho
+                  CALL xc_f03_lda_vxc(xc_func, 1, rho(ii), vrho)
+                  e_rho(ii) = e_rho(ii)+sc*vrho(1)
                END IF
             END DO
 !$OMP           END DO
@@ -1207,9 +1192,9 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
-                  CALL xc_f90_lda_exc_vxc(xc_func, 1, rho(ii), exc, vrho)
-                  e_0(ii) = e_0(ii)+sc*exc*rho(ii)
-                  e_rho(ii) = e_rho(ii)+sc*vrho
+                  CALL xc_f03_lda_exc_vxc(xc_func, 1, rho(ii), exc, vrho)
+                  e_0(ii) = e_0(ii)+sc*exc(1)*rho(ii)
+                  e_rho(ii) = e_rho(ii)+sc*vrho(1)
                END IF
             END DO
 !$OMP           END DO
@@ -1217,8 +1202,8 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
-                  CALL xc_f90_lda_fxc(xc_func, 1, rho(ii), v2rho2)
-                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2
+                  CALL xc_f03_lda_fxc(xc_func, 1, rho(ii), v2rho2)
+                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2(1)
                END IF
             END DO
 !$OMP           END DO
@@ -1226,11 +1211,11 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
-                  CALL xc_f90_lda_exc_vxc(xc_func, 1, rho(ii), exc, vrho)
-                  CALL xc_f90_lda_fxc(xc_func, 1, rho(ii), v2rho2)
-                  e_0(ii) = e_0(ii)+sc*exc*rho(ii)
-                  e_rho(ii) = e_rho(ii)+sc*vrho
-                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2
+                  CALL xc_f03_lda_exc_vxc(xc_func, 1, rho(ii), exc, vrho)
+                  CALL xc_f03_lda_fxc(xc_func, 1, rho(ii), v2rho2)
+                  e_0(ii) = e_0(ii)+sc*exc(1)*rho(ii)
+                  e_rho(ii) = e_rho(ii)+sc*vrho(1)
+                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2(1)
                END IF
             END DO
 !$OMP           END DO
@@ -1238,8 +1223,8 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
-                  CALL xc_f90_lda_kxc(xc_func, 1, rho(ii), v3rho3)
-                  e_rho_rho_rho(ii) = e_rho_rho_rho(ii)+sc*v3rho3
+                  CALL xc_f03_lda_kxc(xc_func, 1, rho(ii), v3rho3)
+                  e_rho_rho_rho(ii) = e_rho_rho_rho(ii)+sc*v3rho3(1)
                END IF
             END DO
 !$OMP           END DO
@@ -1247,11 +1232,11 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
-                  CALL xc_f90_lda(xc_func, 1, rho(ii), exc, vrho, v2rho2, v3rho3)
-                  e_0(ii) = e_0(ii)+sc*exc*rho(ii)
-                  e_rho(ii) = e_rho(ii)+sc*vrho
-                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2
-                  e_rho_rho_rho(ii) = e_rho_rho_rho(ii)+sc*v3rho3
+                  CALL xc_f03_lda(xc_func, 1, rho(ii), exc, vrho, v2rho2, v3rho3)
+                  e_0(ii) = e_0(ii)+sc*exc(1)*rho(ii)
+                  e_rho(ii) = e_rho(ii)+sc*vrho(1)
+                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2(1)
+                  e_rho_rho_rho(ii) = e_rho_rho_rho(ii)+sc*v3rho3(1)
                END IF
             END DO
 !$OMP           END DO
@@ -1261,8 +1246,9 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
-                  CALL xc_f90_gga_exc(xc_func, 1, rho(ii), norm_drho(ii)**2, exc)
-                  e_0(ii) = e_0(ii)+sc*exc*rho(ii)
+                  sigma = norm_drho(ii)**2
+                  CALL xc_f03_gga_exc(xc_func, 1, rho(ii), sigma, exc)
+                  e_0(ii) = e_0(ii)+sc*exc(1)*rho(ii)
                END IF
             END DO
 !$OMP           END DO
@@ -1270,9 +1256,10 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
-                  CALL xc_f90_gga_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, vrho, vsigma)
-                  e_rho(ii) = e_rho(ii)+sc*vrho
-                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma*norm_drho(ii)
+                  sigma = norm_drho(ii)**2
+                  CALL xc_f03_gga_vxc(xc_func, 1, rho(ii), sigma, vrho, vsigma)
+                  e_rho(ii) = e_rho(ii)+sc*vrho(1)
+                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma(1)*norm_drho(ii)
                END IF
             END DO
 !$OMP           END DO
@@ -1280,16 +1267,17 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
+                  sigma = norm_drho(ii)**2
                   IF (no_exc) THEN
-                     CALL xc_f90_gga_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, vrho, vsigma)
+                     CALL xc_f03_gga_vxc(xc_func, 1, rho(ii), sigma, vrho, vsigma)
                      exc = 0.0_dp
                   ELSE
-                     CALL xc_f90_gga_exc_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_gga_exc_vxc(xc_func, 1, rho(ii), sigma, &
                                              exc, vrho, vsigma)
                   END IF
-                  e_0(ii) = e_0(ii)+sc*exc*rho(ii)
-                  e_rho(ii) = e_rho(ii)+sc*vrho
-                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma*norm_drho(ii)
+                  e_0(ii) = e_0(ii)+sc*exc(1)*rho(ii)
+                  e_rho(ii) = e_rho(ii)+sc*vrho(1)
+                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma(1)*norm_drho(ii)
                END IF
             END DO
 !$OMP           END DO
@@ -1297,20 +1285,21 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
+                  sigma = norm_drho(ii)**2
                   IF (no_exc) THEN
-                     CALL xc_f90_gga_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, vrho, vsigma)
-                     CALL xc_f90_gga_fxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_gga_vxc(xc_func, 1, rho(ii), sigma, vrho, vsigma)
+                     CALL xc_f03_gga_fxc(xc_func, 1, rho(ii), sigma, &
                                          v2rho2, v2rhosigma, v2sigma2)
                   ELSE
-                     CALL xc_f90_gga_exc_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_gga_exc_vxc(xc_func, 1, rho(ii), sigma, &
                                              exc, vrho, vsigma)
-                     CALL xc_f90_gga_fxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_gga_fxc(xc_func, 1, rho(ii), sigma, &
                                          v2rho2, v2rhosigma, v2sigma2)
                   END IF
-                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2
-                  e_ndrho_rho(ii) = e_ndrho_rho(ii)+sc*2.0_dp*v2rhosigma*norm_drho(ii)
+                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2(1)
+                  e_ndrho_rho(ii) = e_ndrho_rho(ii)+sc*2.0_dp*v2rhosigma(1)*norm_drho(ii)
                   e_ndrho_ndrho(ii) = e_ndrho_ndrho(ii)+ &
-                                      sc*2.0_dp*(2.0_dp*norm_drho(ii)**2*v2sigma2+vsigma)
+                                      sc*2.0_dp*(2.0_dp*sigma(1)*v2sigma2(1)+vsigma(1))
                END IF
             END DO
 !$OMP           END DO
@@ -1318,24 +1307,25 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF (rho(ii) > epsilon_rho) THEN
+                  sigma = norm_drho(ii)**2
                   IF (no_exc) THEN
-                     CALL xc_f90_gga_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, vrho, vsigma)
-                     CALL xc_f90_gga_fxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_gga_vxc(xc_func, 1, rho(ii), sigma, vrho, vsigma)
+                     CALL xc_f03_gga_fxc(xc_func, 1, rho(ii), sigma, &
                                          v2rho2, v2rhosigma, v2sigma2)
                      exc = 0.0_dp
                   ELSE
-                     CALL xc_f90_gga_exc_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_gga_exc_vxc(xc_func, 1, rho(ii), sigma, &
                                              exc, vrho, vsigma)
-                     CALL xc_f90_gga_fxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_gga_fxc(xc_func, 1, rho(ii), sigma, &
                                          v2rho2, v2rhosigma, v2sigma2)
                   END IF
-                  e_0(ii) = e_0(ii)+sc*exc*rho(ii)
-                  e_rho(ii) = e_rho(ii)+sc*vrho
-                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma*norm_drho(ii)
-                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2
-                  e_ndrho_rho(ii) = e_ndrho_rho(ii)+sc*2.0_dp*v2rhosigma*norm_drho(ii)
+                  e_0(ii) = e_0(ii)+sc*exc(1)*rho(ii)
+                  e_rho(ii) = e_rho(ii)+sc*vrho(1)
+                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma(1)*norm_drho(ii)
+                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2(1)
+                  e_ndrho_rho(ii) = e_ndrho_rho(ii)+sc*2.0_dp*v2rhosigma(1)*norm_drho(ii)
                   e_ndrho_ndrho(ii) = e_ndrho_ndrho(ii)+ &
-                                      sc*2.0_dp*(2.0_dp*norm_drho(ii)**2*v2sigma2+vsigma)
+                                      sc*2.0_dp*(2.0_dp*sigma(1)*v2sigma2(1)+vsigma(1))
                END IF
             END DO
 !$OMP           END DO
@@ -1345,10 +1335,11 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF ((rho(ii) > epsilon_rho) .AND. (tau(ii) > epsilon_tau)) THEN
-                  my_tau = MAX(tau(ii), norm_drho(ii)**2/(8.0_dp*rho(ii)))
-                  CALL xc_f90_mgga_exc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                  sigma = norm_drho(ii)**2
+                  my_tau = MAX(tau(ii), sigma(1)/(8.0_dp*rho(ii)))
+                  CALL xc_f03_mgga_exc(xc_func, 1, rho(ii), sigma, &
                                        laplace_rho(ii), my_tau, exc)
-                  e_0(ii) = e_0(ii)+sc*exc*rho(ii)
+                  e_0(ii) = e_0(ii)+sc*exc(1)*rho(ii)
                END IF
             END DO
 !$OMP           END DO
@@ -1356,13 +1347,14 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF ((rho(ii) > epsilon_rho) .AND. (tau(ii) > epsilon_tau)) THEN
-                  my_tau = MAX(tau(ii), norm_drho(ii)**2/(8.0_dp*rho(ii)))
-                  CALL xc_f90_mgga_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                  sigma = norm_drho(ii)**2
+                  my_tau = MAX(tau(ii), sigma(1)/(8.0_dp*rho(ii)))
+                  CALL xc_f03_mgga_vxc(xc_func, 1, rho(ii), sigma, &
                                        laplace_rho(ii), my_tau, vrho, vsigma, vlapl, vtau)
-                  e_rho(ii) = e_rho(ii)+sc*vrho
-                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma*norm_drho(ii)
-                  e_laplace_rho(ii) = e_laplace_rho(ii)+sc*vlapl
-                  e_tau(ii) = e_tau(ii)+sc*vtau
+                  e_rho(ii) = e_rho(ii)+sc*vrho(1)
+                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma(1)*norm_drho(ii)
+                  e_laplace_rho(ii) = e_laplace_rho(ii)+sc*vlapl(1)
+                  e_tau(ii) = e_tau(ii)+sc*vtau(1)
                END IF
             END DO
 !$OMP           END DO
@@ -1370,20 +1362,21 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF ((rho(ii) > epsilon_rho) .AND. (tau(ii) > epsilon_tau)) THEN
-                  my_tau = MAX(tau(ii), norm_drho(ii)**2/(8.0_dp*rho(ii)))
+                  sigma = norm_drho(ii)**2
+                  my_tau = MAX(tau(ii), sigma(1)/(8.0_dp*rho(ii)))
                   IF (no_exc) THEN
-                     CALL xc_f90_mgga_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_mgga_vxc(xc_func, 1, rho(ii), sigma, &
                                           laplace_rho(ii), my_tau, vrho, vsigma, vlapl, vtau)
                      exc = 0.0_dp
                   ELSE
-                     CALL xc_f90_mgga_exc_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_mgga_exc_vxc(xc_func, 1, rho(ii), sigma, &
                                               laplace_rho(ii), my_tau, exc, vrho, vsigma, vlapl, vtau)
                   END IF
-                  e_0(ii) = e_0(ii)+sc*exc*rho(ii)
-                  e_rho(ii) = e_rho(ii)+sc*vrho
-                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma*norm_drho(ii)
-                  e_laplace_rho(ii) = e_laplace_rho(ii)+sc*vlapl
-                  e_tau(ii) = e_tau(ii)+sc*vtau
+                  e_0(ii) = e_0(ii)+sc*exc(1)*rho(ii)
+                  e_rho(ii) = e_rho(ii)+sc*vrho(1)
+                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma(1)*norm_drho(ii)
+                  e_laplace_rho(ii) = e_laplace_rho(ii)+sc*vlapl(1)
+                  e_tau(ii) = e_tau(ii)+sc*vtau(1)
                END IF
             END DO
 !$OMP           END DO
@@ -1391,32 +1384,33 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF ((rho(ii) > epsilon_rho) .AND. (tau(ii) > epsilon_tau)) THEN
-                  my_tau = MAX(tau(ii), norm_drho(ii)**2/(8.0_dp*rho(ii)))
+                  sigma = norm_drho(ii)**2
+                  my_tau = MAX(tau(ii), sigma(1)/(8.0_dp*rho(ii)))
                   IF (no_exc) THEN
-                     CALL xc_f90_mgga_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_mgga_vxc(xc_func, 1, rho(ii), sigma, &
                                           laplace_rho(ii), my_tau, vrho, vsigma, vlapl, vtau)
-                     CALL xc_f90_mgga_fxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_mgga_fxc(xc_func, 1, rho(ii), sigma, &
                                           laplace_rho(ii), my_tau, &
                                           v2rho2, v2sigma2, v2lapl2, v2tau2, v2rhosigma, v2rholapl, &
                                           v2rhotau, v2sigmalapl, v2sigmatau, v2lapltau)
                   ELSE
-                     CALL xc_f90_mgga(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_mgga(xc_func, 1, rho(ii), sigma, &
                                       laplace_rho(ii), my_tau, exc, vrho, vsigma, vlapl, vtau, &
                                       v2rho2, v2sigma2, v2lapl2, v2tau2, v2rhosigma, v2rholapl, &
                                       v2rhotau, v2sigmalapl, v2sigmatau, v2lapltau)
                   END IF
-                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2
-                  e_ndrho_rho(ii) = e_ndrho_rho(ii)+sc*2.0_dp*v2rhosigma*norm_drho(ii)
+                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2(1)
+                  e_ndrho_rho(ii) = e_ndrho_rho(ii)+sc*2.0_dp*v2rhosigma(1)*norm_drho(ii)
                   e_ndrho_ndrho(ii) = e_ndrho_ndrho(ii)+ &
-                                      sc*2.0_dp*(2.0_dp*norm_drho(ii)**2*v2sigma2+vsigma)
-                  e_rho_laplace_rho(ii) = e_rho_laplace_rho(ii)+sc*v2rholapl
-                  e_rho_tau(ii) = e_rho_tau(ii)+sc*v2rhotau
+                                      sc*2.0_dp*(2.0_dp*sigma(1)*v2sigma2(1)+vsigma(1))
+                  e_rho_laplace_rho(ii) = e_rho_laplace_rho(ii)+sc*v2rholapl(1)
+                  e_rho_tau(ii) = e_rho_tau(ii)+sc*v2rhotau(1)
                   e_ndrho_laplace_rho(ii) = e_ndrho_laplace_rho(ii)+ &
-                                            sc*2.0_dp*v2sigmalapl*norm_drho(ii)
-                  e_ndrho_tau(ii) = e_ndrho_tau(ii)+sc*2.0_dp*v2sigmatau*norm_drho(ii)
-                  e_laplace_rho_laplace_rho(ii) = e_laplace_rho_laplace_rho(ii)+sc*v2lapl2
-                  e_laplace_rho_tau(ii) = e_laplace_rho_tau(ii)+sc*v2lapltau
-                  e_tau_tau(ii) = e_tau_tau(ii)+sc*v2tau2
+                                            sc*2.0_dp*v2sigmalapl(1)*norm_drho(ii)
+                  e_ndrho_tau(ii) = e_ndrho_tau(ii)+sc*2.0_dp*v2sigmatau(1)*norm_drho(ii)
+                  e_laplace_rho_laplace_rho(ii) = e_laplace_rho_laplace_rho(ii)+sc*v2lapl2(1)
+                  e_laplace_rho_tau(ii) = e_laplace_rho_tau(ii)+sc*v2lapltau(1)
+                  e_tau_tau(ii) = e_tau_tau(ii)+sc*v2tau2(1)
                END IF
             END DO
 !$OMP           END DO
@@ -1424,38 +1418,39 @@
 !$OMP           DO
             DO ii = 1, npoints
                IF ((rho(ii) > epsilon_rho) .AND. (tau(ii) > epsilon_tau)) THEN
-                  my_tau = MAX(tau(ii), norm_drho(ii)**2/(8.0_dp*rho(ii)))
+                  sigma = norm_drho(ii)**2
+                  my_tau = MAX(tau(ii), sigma(1)/(8.0_dp*rho(ii)))
                   IF (no_exc) THEN
-                     CALL xc_f90_mgga_vxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_mgga_vxc(xc_func, 1, rho(ii), sigma, &
                                           laplace_rho(ii), my_tau, vrho, vsigma, vlapl, vtau)
-                     CALL xc_f90_mgga_fxc(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_mgga_fxc(xc_func, 1, rho(ii), sigma, &
                                           laplace_rho(ii), my_tau, &
                                           v2rho2, v2sigma2, v2lapl2, v2tau2, v2rhosigma, v2rholapl, &
                                           v2rhotau, v2sigmalapl, v2sigmatau, v2lapltau)
                      exc = 0.0_dp
                   ELSE
-                     CALL xc_f90_mgga(xc_func, 1, rho(ii), norm_drho(ii)**2, &
+                     CALL xc_f03_mgga(xc_func, 1, rho(ii), sigma, &
                                       laplace_rho(ii), my_tau, exc, vrho, vsigma, vlapl, vtau, &
                                       v2rho2, v2sigma2, v2lapl2, v2tau2, v2rhosigma, v2rholapl, &
                                       v2rhotau, v2sigmalapl, v2sigmatau, v2lapltau)
                   END IF
-                  e_0(ii) = e_0(ii)+sc*exc*rho(ii)
-                  e_rho(ii) = e_rho(ii)+sc*vrho
-                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma*norm_drho(ii)
-                  e_laplace_rho(ii) = e_laplace_rho(ii)+sc*vlapl
-                  e_tau(ii) = e_tau(ii)+sc*vtau
-                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2
-                  e_ndrho_rho(ii) = e_ndrho_rho(ii)+sc*2.0_dp*v2rhosigma*norm_drho(ii)
+                  e_0(ii) = e_0(ii)+sc*exc(1)*rho(ii)
+                  e_rho(ii) = e_rho(ii)+sc*vrho(1)
+                  e_ndrho(ii) = e_ndrho(ii)+sc*2.0_dp*vsigma(1)*norm_drho(ii)
+                  e_laplace_rho(ii) = e_laplace_rho(ii)+sc*vlapl(1)
+                  e_tau(ii) = e_tau(ii)+sc*vtau(1)
+                  e_rho_rho(ii) = e_rho_rho(ii)+sc*v2rho2(1)
+                  e_ndrho_rho(ii) = e_ndrho_rho(ii)+sc*2.0_dp*v2rhosigma(1)*norm_drho(ii)
                   e_ndrho_ndrho(ii) = e_ndrho_ndrho(ii)+ &
-                                      sc*2.0_dp*(2.0_dp*norm_drho(ii)**2*v2sigma2+vsigma)
-                  e_rho_laplace_rho(ii) = e_rho_laplace_rho(ii)+sc*v2rholapl
-                  e_rho_tau(ii) = e_rho_tau(ii)+sc*v2rhotau
+                                      sc*2.0_dp*(2.0_dp*sigma(1)*v2sigma2(1)+vsigma(1))
+                  e_rho_laplace_rho(ii) = e_rho_laplace_rho(ii)+sc*v2rholapl(1)
+                  e_rho_tau(ii) = e_rho_tau(ii)+sc*v2rhotau(1)
                   e_ndrho_laplace_rho(ii) = e_ndrho_laplace_rho(ii)+ &
-                                            sc*2.0_dp*v2sigmalapl*norm_drho(ii)
-                  e_ndrho_tau(ii) = e_ndrho_tau(ii)+sc*2.0_dp*v2sigmatau*norm_drho(ii)
-                  e_laplace_rho_laplace_rho(ii) = e_laplace_rho_laplace_rho(ii)+sc*v2lapl2
-                  e_laplace_rho_tau(ii) = e_laplace_rho_tau(ii)+sc*v2lapltau
-                  e_tau_tau(ii) = e_tau_tau(ii)+sc*v2tau2
+                                            sc*2.0_dp*v2sigmalapl(1)*norm_drho(ii)
+                  e_ndrho_tau(ii) = e_ndrho_tau(ii)+sc*2.0_dp*v2sigmatau(1)*norm_drho(ii)
+                  e_laplace_rho_laplace_rho(ii) = e_laplace_rho_laplace_rho(ii)+sc*v2lapl2(1)
+                  e_laplace_rho_tau(ii) = e_laplace_rho_tau(ii)+sc*v2lapltau(1)
+                  e_tau_tau(ii) = e_tau_tau(ii)+sc*v2tau2(1)
                END IF
             END DO
 !$OMP           END DO
@@ -1464,12 +1459,10 @@
          CPABORT(TRIM(func_name)//": this XC_FAMILY is currently not supported.")
       END SELECT
 
-      CALL xc_f90_func_end(xc_func)
-#else
-      CPABORT("In order to use libxc you need to download and install it")
-#endif
+      CALL xc_f03_func_end(xc_func)
 
    END SUBROUTINE libxc_lda_calc
+#endif
 
 ! **************************************************************************************************
 !> \brief libxc exchange-correlation functionals
@@ -1552,6 +1545,7 @@
 !> \param params parameters of the functional
 !> \author F. Tran
 ! **************************************************************************************************
+#if defined (__LIBXC)
    SUBROUTINE libxc_lsd_calc(rhoa, rhob, norm_drho, norm_drhoa, &
                              norm_drhob, laplace_rhoa, laplace_rhob, tau_a, tau_b, &
                              e_0, e_rhoa, e_rhob, e_ndrho, e_ndrhoa, e_ndrhob, &
